#ifndef _CLASSES
#define _CLASSES



class Unite
{
	public :

	void Create(int styleUnite, int xUnite, int yUnite);
	void Delete();
	void Stop(float time);
	void TestAction();
	void Attack(Unite* uniteAttaquee);
	void Attack_Act();
	void LooseHP(int hPLoosed, int hPLoosedAA);
	void GoTo(int x, int y);
	void Move();
	void RepairHP(int HPgets);
	void SpecialCapacity();
	bool Cargo_In(Unite* uniteGet);
	void Cargo_Out(int uniteGet, int x, int y);
	void Out_Position();
	void In_Position(int xPos, int yPos);

	char Get_Type();
	int Get_HealthPoints();
	int Get_PositionX();
	int Get_PositionY();
	float Get_LastTime();
	int Get_HealthPointsMax();
	int Get_Attack();
	int Get_AA_Attack();
	int Get_Range();
	int Get_ShockWave();
	float Get_ShootTime();
	int Get_Visibility();
	int Get_CargoMax();
	int Get_CargoNumber();
	float Get_MoveTime();
	Unite* Get_CargoUnit(int uniteGet);
	bool Get_IsStop();
	bool Get_Move();
	bool Get_IsAttacking();

	int Get_Sprite(int x, int y);
	

	protected :

	char m_Type;
	int m_HealthPoints;
	float m_LastTime;
	Unite* m_LastShoot;
	Unite* mTab_Cargo[5];
	int m_PositionX, m_GoTo_X;
	int m_PositionY, m_GoTo_Y;
	float m_Stop;

};

class WorldShip
{
	public :

	void Create(char type, int x, int y);
	void Delete();
	int Get_Sprite(int x, int y);

	protected :

	int m_Ax;
	int m_Ay;
	char m_Type;

};

#endif