#include "Game.hpp"
#include "Graphics.hpp"
#include "Timer.hpp"
#include "Load.hpp"

extern "C"
{

#include "fxlib.h"

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	int pos = 3;

	while(IsKeyDown(KEY_CTRL_EXE));

	Screen_Loading();
	Trailer();

	Timer_Initialize();

	while(1) {
		Bdisp_AllClr_DDVRAM();

		Screen_Main();
		locate(3,1);
		Print((unsigned char*) "Command the Earth");
		locate(5,3);
		Print((unsigned char*) "o Play");
		locate(7,4);
		Print((unsigned char*) "Campaign");
		locate(7,5);
		Print((unsigned char*) "Continue");
		locate(7,6);
		Print((unsigned char*) "Help");
		locate(7,7);
		Print((unsigned char*) "Quit");

		while(IsKeyDown(KEY_CTRL_EXE));
		while(IsKeyUp(KEY_CTRL_EXE)) {
			if(IsKeyDown(KEY_CTRL_UP) && (pos != 3)) {
				locate(5, pos); Print(" ");
				pos --;
				locate(5, pos); Print("o");
				Sleep(250);
			}
			if(IsKeyDown(KEY_CTRL_DOWN) && (pos != 7)) {
				locate(5, pos); Print(" ");
				pos ++;
				locate(5, pos); Print("o");
				Sleep(250);
			}
			Bdisp_PutDisp_DD();
		}

		Screen_Loading();

		if(pos == 3) Alea();
		if(pos == 4) Missions();
		if(pos == 5) if(Loader()) Game();
		if(pos == 6) Tutorial();
		if(pos == 7) Screen_Quit();
		pos = 3;
	}

	return 1;
}




#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section
}