extern "C"
{
#include "fxlib.h"
#include "stdlib.h"
#include "stddef.h"
#include "math.h"
}

#include "ArInt.hpp"
#include "Classes.hpp"
#include "Game.hpp"
#include "Graphics.hpp"
#include "Timer.hpp"
#include "OtherFunc.hpp"
#include "Load.hpp"

// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________

char tab [14][7];
int MAP_AREA;
unsigned char MAP_XMAX, MAP_YMAX;

unsigned char Ax, Ay, curX, curY;
Unite UnitesAlliees[50];
Unite UnitesEnnemies[50];
WorldShip Monde[16];
int money;
char timePress;
bool Cross;
bool AsusDrivers;
bool RichMen;

// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________

void Cross_On()
{
	Cross = true;
}

void Cross_Off()
{
	Cross = false;
}

void CenterCam(int x, int y)
{
	x-=7;
	if(x < 1) x = 1;
	if(x > 48) x = 48; 
	y-=3;
	if(y < 1) y = 1;
	if(y > 56) y = 56; 
	Ax = x; Ay = y;
}

int Test_XY(int x, int y)
{
	char k = 0;
	while (k < 50) {
		if(k < 16) if (Monde[k].Get_Sprite(x, y)) return Monde[k].Get_Sprite(x,y);
		if (UnitesAlliees[k].Get_Sprite(x, y)) return UnitesAlliees[k].Get_Sprite(x,y);
		if (UnitesEnnemies[k].Get_Sprite(x, y)) return UnitesEnnemies[k].Get_Sprite(x,y);
		k++;
	}
	return 0;
}

void Timer_Test()
{
	char k;
	k = 0;
	while (k < 50) {
		if (UnitesAlliees[k].Get_Type() != 0) {
			if (UnitesAlliees[k].Get_Type() == 10) {
				if(UnitesAlliees[k].Get_IsStop()) Revenu(10);
			}
			if ((UnitesAlliees[k].Get_Type() == 11) && (UnitesAlliees[k].Get_IsStop())) {
				for(int i = 0; i < 50; i++) {
					if(UnitesAlliees[i].Get_Type() < 10) if(Test_Range(UnitesAlliees[k].Get_PositionX(), UnitesAlliees[k].Get_PositionY(), UnitesAlliees[k].Get_Range(), UnitesAlliees[i].Get_PositionX(), UnitesAlliees[i].Get_PositionY())) UnitesAlliees[i].RepairHP(5);
				}
			}
			if (((UnitesAlliees[k].Get_Type() == 15) || (UnitesAlliees[k].Get_Type() == 16) || (UnitesAlliees[k].Get_Type() == 40)) && (UnitesAlliees[k].Get_IsStop())) {
				for(int i = 0; i < 50; i++) {
					if(Test_Range(UnitesAlliees[k].Get_PositionX(), UnitesAlliees[k].Get_PositionY(), UnitesAlliees[k].Get_Range(), UnitesEnnemies[i].Get_PositionX(), UnitesEnnemies[i].Get_PositionY())) UnitesAlliees[k].Attack(&UnitesEnnemies[i]);
				}
			}
			UnitesAlliees[k].TestAction();
		}
		if (UnitesEnnemies[k].Get_Type() != 0) {
			if (((UnitesEnnemies[k].Get_Type() == 15) || (UnitesEnnemies[k].Get_Type() == 16) || (UnitesEnnemies[k].Get_Type() == 40)) && (UnitesEnnemies[k].Get_IsStop())) {
				for(int i = 0; i < 50; i++) {
					if(Test_Range(UnitesEnnemies[k].Get_PositionX(), UnitesEnnemies[k].Get_PositionY(), UnitesEnnemies[k].Get_Range(), UnitesAlliees[i].Get_PositionX(), UnitesAlliees[i].Get_PositionY())) UnitesEnnemies[k].Attack(&UnitesAlliees[i]);
				}
			}
			if (UnitesEnnemies[k].Get_Type() == 10) {
				if(UnitesEnnemies[k].Get_IsStop()) Make_MoneyMore(10);
			}
			UnitesEnnemies[k].TestAction();
		}
		k++;
	}
	Bdisp_PutScreen();
}

int End_Test()
{
	int j = 0;
	for(int i = 0; i<50; i++) if(UnitesAlliees[i].Get_Type() == 0) j++;
	if(j == 50) return 1;
	j = 0;
	for(int i = 0; i<50; i++) if(UnitesEnnemies[i].Get_Type() == 0) j++;
	if(j == 50) return 2;
	return 0;
}

// ===== CAN/CANSEE =====

bool CanSee_Allie(Unite* n)
{
	for(int i = 0; i<50; i++) if(Test_Range(n->Get_PositionX(), n->Get_PositionY(), n->Get_Visibility(), UnitesAlliees[i].Get_PositionX(), UnitesAlliees[i].Get_PositionY())) return true;
	return false;
}

bool CanSee_Ennemie(Unite* n, int type)
{
	for(int i = 0; i<50; i++) if(UnitesEnnemies[i].Get_Type() == type) if(Test_Range(n->Get_PositionX(), n->Get_PositionY(), n->Get_Range(), UnitesEnnemies[i].Get_PositionX(), UnitesEnnemies[i].Get_PositionY())) return true;
	return false;
}

bool Can_Build(int n, int x, int y)
{
	for(int i = 0; i<50; i++) if(UnitesAlliees[i].Get_Type() == n) if(Test_Range(UnitesAlliees[i].Get_PositionX(), UnitesAlliees[i].Get_PositionY(), UnitesAlliees[i].Get_Range(), x, y) || ((n >= 20) && (Test_Range(UnitesAlliees[i].Get_PositionX()+1, UnitesAlliees[i].Get_PositionY(), UnitesAlliees[i].Get_Range(), x, y) || Test_Range(UnitesAlliees[i].Get_PositionX(), UnitesAlliees[i].Get_PositionY()+1, UnitesAlliees[i].Get_Range(), x, y) || Test_Range(UnitesAlliees[i].Get_PositionX()+1, UnitesAlliees[i].Get_PositionY()+1, UnitesAlliees[i].Get_Range(), x, y)))) return true;
	return false;
}

// ===== POINTERS : UNITS =====

Unite* NewUnit_Alliee()
{
	for(int i = 0; i<50; i++) if(UnitesAlliees[i].Get_Type() == 0) return &(UnitesAlliees[i]);
	return 0;
}

Unite* NewUnit_Ennemie()
{
	for(int i = 0; i<50; i++) if(UnitesEnnemies[i].Get_Type() == 0) return &(UnitesEnnemies[i]);
	return 0;
}

Unite* GetUnit_Alliee(int i)
{
	if((i < 50) && (i >= 0)) return &(UnitesAlliees[i]);
	return 0;
}

Unite* GetUnit_Ennemie(int i)
{
	if((i < 50) && (i >= 0)) return &(UnitesEnnemies[i]);
	return 0;
}

Unite* Select_UniteAlliee()
{
	int x = 0, y = 0;
	Get_Position(&x, &y);
	for(int i = 1; i<50; i++) if(UnitesAlliees[i].Get_Sprite(x, y)) return &(UnitesAlliees[i]);
	return 0;
}

Unite* Select_UniteEnnemie()
{
	int x = 0, y = 0;
	Get_Position(&x, &y);
	for(int i = 1; i<50; i++) if(UnitesEnnemies[i].Get_Sprite(x, y)) return &(UnitesEnnemies[i]);
	return 0;
}

// ===== GESTION : MONEY =====

bool Depense(int n)
{
	if((money < n) && !RichMen) return false;
	if(!RichMen) money -= n;
	return true;
}

bool Revenu(int n)
{
	money += n;
	return true;
}

int Get_MAP_XMAX()
{
	return MAP_XMAX;
}

int Get_MAP_YMAX()
{
	return MAP_YMAX;
}

// ===== GESTION : MOUSE =====

void Get_Position(int* x, int* y)
{
	while(IsKeyUp(KEY_CTRL_F1)) {
		if(IsKeyDown(KEY_CTRL_UP) || IsKeyDown(KEY_CTRL_DOWN) || IsKeyDown(KEY_CTRL_LEFT) || IsKeyDown(KEY_CTRL_RIGHT)) {
			RestoreDisp(1);
			if (IsKeyDown(KEY_CTRL_UP)) {
				curY--;
				if(curY == 0) {
					curY = 1;
					if (Ay != 1) Ay--;
					Bdisp_PutScreen();
				}
			}
			if (IsKeyDown(KEY_CTRL_DOWN)) {
				curY++;
				if(curY == 55) {
					curY = 54;
					if (Ay < MAP_YMAX-6) Ay++;
					Bdisp_PutScreen();
				}
			}
			if (IsKeyDown(KEY_CTRL_LEFT)) {
				curX--;
				if(curX == 0) {
					curX = 1;
					if (Ax != 1) Ax--;
					Bdisp_PutScreen();
				}
			}
			if (IsKeyDown(KEY_CTRL_RIGHT)) {
				curX++;
				if(curX == 110) {
					curX = 109;
					if (Ax < MAP_XMAX-13) Ax++;
					Bdisp_PutScreen();
				}
			}
			Bdisp_Cursor(curX, curY);
			Bdisp_PutDisp_DD();
		}
	}
	*x = curX/8+Ax;
	*y = curY/8+Ay;
}

int get_PositionX_Mouse()
{
	return curX/8+Ax;
}

int get_PositionY_Mouse()
{
	return curY/8+Ay;
}

// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________


void Get()
{
	int curI, curJ, k;

// ===== KEY : F1 =====

	if(IsKeyDown(KEY_CTRL_F1)) {
		if(IsKeyUp(KEY_CTRL_F6)) Unselect();
		curI = curX / 8;
		curJ = curY / 8;
		k = 0;
		while (k < 50) {
			if (UnitesAlliees[k].Get_Sprite(curI+Ax, curJ+Ay)) Select(&UnitesAlliees[k], true);
			if (UnitesEnnemies[k].Get_Sprite(curI+Ax, curJ+Ay)) Select(&UnitesEnnemies[k], false);
			k++;
		}
	}

// ===== KEY : F2 =====

	if(IsKeyDown(KEY_CTRL_F2)) {
		curI = (curX / 8);
		curJ = (curY / 8);
		if (Test_XY(curI+Ax, curJ+Ay) == 0) {
			Sel_Move(curI+Ax, curJ+Ay);
			Sel_Attack(0);
		}
		else {
			k = 0;
			while (k < 50) {
				if (UnitesAlliees[k].Get_Sprite(curI+Ax, curJ+Ay)) Sel_Cargo(&UnitesAlliees[k]);
				if (UnitesEnnemies[k].Get_Sprite(curI+Ax, curJ+Ay)) Sel_Attack(&UnitesEnnemies[k]);
				k++;
			}
		}
	}

// ===== KEY : F3 =====

	if(IsKeyDown(KEY_CTRL_F3)) {
		Timer_Set_Off();
		int I = curY+32;
		while (I > 54) I = I-8;
		I = I-32;
		while(I < 0) I = I+8;

		if(((Sel_Num() == 20) || (Sel_Num() == 25) || (Sel_Num() == 30) || (Sel_Num() == 35)) && Sel_IsStop()) {
				Bdisp_MenuPart(curX, I, (unsigned char*) "Build");
		}

		Bdisp_MenuPart(curX, I*!(((Sel_Num() == 20) || (Sel_Num() == 25) || (Sel_Num() == 30) || (Sel_Num() == 35)) && Sel_IsStop()) + (I+8)*(((Sel_Num() == 20) || (Sel_Num() == 25) || (Sel_Num() == 30) || (Sel_Num() == 35)) && Sel_IsStop()), (unsigned char*) "Info");

		if((Sel_Num() == 4) || (Sel_Num() == 7) || (Sel_Num() == 10) || (Sel_Num() == 12) || (Sel_Num() == 20) || (Sel_Num() == 40) || (Sel_Num() == 50)) {
			Bdisp_MenuPart(curX, (I+8)*!((Sel_Num() == 20) && Sel_IsStop()) + (I+16)*((Sel_Num() == 20) && Sel_IsStop()), (unsigned char*) "Cargo");
		}

		if((Sel_Num() == 3) || (Sel_Num() == 4) || (Sel_Num() == 12) || (Sel_Num() == 50)) {
			Bdisp_MenuPart(curX, (I+8)*(Sel_Num() == 3) +(I+16)*!(Sel_Num() == 3), (unsigned char*) "Spe");
		}

		int A = 1;
		int Amax = 1+(((Sel_Num() == 20) || (Sel_Num() == 25) || (Sel_Num() == 30) || (Sel_Num() == 35)) && Sel_IsStop()) + ((Sel_Num() == 4) || (Sel_Num() == 7) || (Sel_Num() == 10) || (Sel_Num() == 12) || (Sel_Num() == 20) || (Sel_Num() == 40) || (Sel_Num() == 50)) + ((Sel_Num() == 3) || (Sel_Num() == 4) || (Sel_Num() == 12) || (Sel_Num() == 50));

		for(int i = 2; i < 9; i++) for(int j = 1; j < 21; j++) {
			Bdisp_SetPoint_VRAM(curX+j, I+i+8*(A-1), !Bdisp_GetPoint_VRAM(curX+j, I+i+8*(A-1)));
		}


		while (IsKeyUp(KEY_CTRL_EXIT)) {
			if(IsKeyDown(KEY_CTRL_UP) && (A > 1)) {
				for(int i = 2; i < 9; i++) for(int j = 1; j < 21; j++) Bdisp_SetPoint_VRAM(curX+j, I+i+8*(A-1), !Bdisp_GetPoint_VRAM(curX+j, I+i+8*(A-1)));
				A--;
				Sleep(150);
				for(int i = 2; i < 9; i++) for(int j = 1; j < 21; j++) Bdisp_SetPoint_VRAM(curX+j, I+i+8*(A-1), !Bdisp_GetPoint_VRAM(curX+j, I+i+8*(A-1)));
			}
			if(IsKeyDown(KEY_CTRL_DOWN) && (A < Amax)) {
				for(int i = 2; i < 9; i++) for(int j = 1; j < 21; j++) Bdisp_SetPoint_VRAM(curX+j, I+i+8*(A-1), !Bdisp_GetPoint_VRAM(curX+j, I+i+8*(A-1)));
				A++;
				Sleep(150);
				for(int i = 2; i < 9; i++) for(int j = 1; j < 21; j++) Bdisp_SetPoint_VRAM(curX+j, I+i+8*(A-1), !Bdisp_GetPoint_VRAM(curX+j, I+i+8*(A-1)));
			}
			if(IsKeyDown(KEY_CTRL_EXE)) {

				if (((Sel_Num() == 20) || (Sel_Num() == 25) || (Sel_Num() == 30) || (Sel_Num() == 35)) && !Sel_IsStop()) A++;

				if ((A == 1) && ((Sel_Num() == 20) || (Sel_Num() == 25) || (Sel_Num() == 30) || (Sel_Num() == 35))) Sel_Build();

				if ((Sel_Num() == 20) || (Sel_Num() == 25) || (Sel_Num() == 30) || (Sel_Num() == 35)) {
					if (A == 2) {
						Bdisp_Info();
						while (IsKeyUp(KEY_CTRL_EXE));
						while (IsKeyDown(KEY_CTRL_EXE));
						while (IsKeyUp(KEY_CTRL_EXE));
					}
				}
				else {
					if (A == 1) {
						Bdisp_Info();
						while (IsKeyUp(KEY_CTRL_EXE));
					}
				}

				if (Sel_Num() == 20) {
					if (A == 3) Sel_CargoOut();
				}
				else {
					if ((A == 2) && ((Sel_Num() == 4) || (Sel_Num() == 12) || (Sel_Num() == 20) || (Sel_Num() == 40) || (Sel_Num() == 50))) Sel_CargoOut();
				}

				if (Sel_Num() == 3) {
					if (A == 2) Sel_CapaSpe();
				}
				else {
					if ((A == 3) && ((Sel_Num() == 3) || (Sel_Num() == 4) || (Sel_Num() == 12) || (Sel_Num() == 50))) Sel_CapaSpe();
				}

				break;
			}
			Bdisp_PutDisp_DD();
		}
		Timer_Set_On();
	}

// ===== KEY : FD =====

	if(IsKeyDown(KEY_CTRL_FD)) {
		Unselect();
		k = 0;
		while (k < 50) {
			if (UnitesAlliees[k].Get_Type() == 20) Select(&UnitesAlliees[k], true);
			k++;
		}
	}

// ===== Key : F4 =====

	if(IsKeyDown(KEY_CTRL_F4)) {
		Timer_Set_Off();
		while (IsKeyUp(KEY_CTRL_EXIT)) {
			char ch[10];
			PopUpWin(3);
			locate(5,3);
			Print((unsigned char*) "Player 1 :");
			locate(5,4);
			Print((unsigned char*) "$");
			int2str(ch, money);
			locate(7,4);
			Print((unsigned char*) ch);
			locate(3,5);
			Print((unsigned char*) "Time :");
			int2str(ch, (((int) Timer_GetTime() /3600) % 60));
			locate(10,5);
			Print((unsigned char*) ch);
			locate(11,5);
			Print((unsigned char*) ".");
			int2str(ch, (int)(((int) Timer_GetTime() /60) % 60));
			locate(12,5);
			Print((unsigned char*) ch);
			locate(14,5);
			Print((unsigned char*) ".");
			int2str(ch, (int)((int) Timer_GetTime() % 60));
			locate(15,5);
			Print((unsigned char*) ch);
			locate(17,5);
			Print((unsigned char*) ".");
			int2str(ch, (int)((int)(Timer_GetTime() * 10) % 10));
			locate(18,5);
			Print((unsigned char*) ch);

			Bdisp_PutDisp_DD();

			if(IsKeyDown(KEY_CTRL_F2)) {
				int Cheat = 0;
				char ch[10];
				while(IsKeyUp(KEY_CTRL_EXE)) {
					int2str(ch, Cheat);
					PopUpWin(2);
					locate(9,3); Print((unsigned char*) "Code :");
					locate(8,4); Print((unsigned char*) ">");
					locate(9,4); Print((unsigned char*) ch);
					locate(15,4); Print((unsigned char*) "<");
					Bdisp_PutDisp_DD();
					if(Cheat < 100000) {
						if(IsKeyDown(KEY_CHAR_0)) {
							Cheat = 10*Cheat + 0;
							while(IsKeyDown(KEY_CHAR_0));
						}
						if(IsKeyDown(KEY_CHAR_1)) {
							Cheat = 10*Cheat + 1;
							while(IsKeyDown(KEY_CHAR_1));
						}
						if(IsKeyDown(KEY_CHAR_2)) {
							Cheat = 10*Cheat + 2;
							while(IsKeyDown(KEY_CHAR_2));
						}
						if(IsKeyDown(KEY_CHAR_3)) {
							Cheat = 10*Cheat + 3;
							while(IsKeyDown(KEY_CHAR_3));
						}
						if(IsKeyDown(KEY_CHAR_4)) {
							Cheat = 10*Cheat + 4;
							while(IsKeyDown(KEY_CHAR_4));
						}
						if(IsKeyDown(KEY_CHAR_5)) {
							Cheat = 10*Cheat + 5;
							while(IsKeyDown(KEY_CHAR_5));
						}
						if(IsKeyDown(KEY_CHAR_6)) {
							Cheat = 10*Cheat + 6;
							while(IsKeyDown(KEY_CHAR_6));
						}
						if(IsKeyDown(KEY_CHAR_7)) {
							Cheat = 10*Cheat + 7;
							while(IsKeyDown(KEY_CHAR_7));
						}
						if(IsKeyDown(KEY_CHAR_8)) {
							Cheat = 10*Cheat + 8;
							while(IsKeyDown(KEY_CHAR_8));
						}
						if(IsKeyDown(KEY_CHAR_9)) {
							Cheat = 10*Cheat + 9;
							while(IsKeyDown(KEY_CHAR_9));
						}
					}
					if(IsKeyDown(KEY_CTRL_DEL) && (Cheat > 0)) {
						Cheat /= 10;
						while(IsKeyDown(KEY_CTRL_DEL));
					}
				}
				if(Cheat == 543210) {
					AsusDrivers = true;
					RichMen = true;
					Set_Brainstorm(true);
					PopUpWin(1); locate(5,4); Print((unsigned char*) "Cheater >< !");
				}
				if(Cheat == 969696) {
					RichMen = true;
					PopUpWin(1); locate(6,4); Print((unsigned char*) "Cheat On !");
				}
				if(Cheat == 314159) {
					AsusDrivers = true;
					PopUpWin(1); locate(6,4); Print((unsigned char*) "Cheat on !");
				}
				if(Cheat == 72000) {
					Set_Brainstorm(true);
					PopUpWin(1); locate(6,4); Print((unsigned char*) "Cheat On !");
				}
				if(Cheat == 1) {
					AsusDrivers = false;
					RichMen = false;
					Set_Brainstorm(false);
					PopUpWin(1); locate(6,4); Print((unsigned char*) "Cheat Off !");
				}
				Bdisp_PutDisp_DD();
				while(IsKeyDown(KEY_CTRL_EXE)); while(IsKeyUp(KEY_CTRL_EXE));
				break;
			}
		}
		Timer_Set_On();
	}

// ===== Key : F5 =====

	if(IsKeyDown(KEY_CTRL_F5)) {
		while (IsKeyDown(KEY_CTRL_F5));
		Timer_Set_Off();
		Bdisp_AllClr_VRAM();
		Bdisp_DrawLineVRAM(MAP_XMAX+1,0,MAP_XMAX+1,MAP_YMAX+1);
		Bdisp_DrawLineVRAM(0,MAP_YMAX+1,MAP_XMAX+1,MAP_YMAX+1);
		if(!AsusDrivers) {
			for(int i = 0; i<=MAP_XMAX; i++) {
				Bdisp_DrawLineVRAM(i,0,i,MAP_YMAX);
				for(int j = 0; j<= MAP_YMAX; j++) {
					for(int k = 0; k<50; k++) {
						if((Test_Range(UnitesAlliees[k].Get_PositionX(), UnitesAlliees[k].Get_PositionY(), UnitesAlliees[k].Get_Visibility(), i, j)) || ((UnitesAlliees[k].Get_Type() >= 20) && (Test_Range(UnitesAlliees[k].Get_PositionX(), UnitesAlliees[k].Get_PositionY()+1, UnitesAlliees[k].Get_Visibility(), i, j) || Test_Range(UnitesAlliees[k].Get_PositionX()+1, UnitesAlliees[k].Get_PositionY(), UnitesAlliees[k].Get_Visibility(), i, j) || Test_Range(UnitesAlliees[k].Get_PositionX()+1, UnitesAlliees[k].Get_PositionY()+1, UnitesAlliees[k].Get_Visibility(), i, j)))){
							Bdisp_SetPoint_VRAM(i,j,0);
							k = 50;
						}
					}
				}
			}
		}

		Bdisp_PutDisp_DD();
		SaveDisp(10);
		Ax--; Ay--;
		while (IsKeyUp(KEY_CTRL_EXIT)) {
			for(int i = 0; i <= MAP_XMAX; i++) for(int j = 0; j <= MAP_YMAX; j++) for(k = 0; k<50; k++) if(UnitesAlliees[k].Get_Sprite(i,j)) Bdisp_SetPoint_VRAM(i,j,1);
			for(int i = 0; i < 7; i++) Bdisp_SetPoint_VRAM(Ax, Ay+i, !Bdisp_GetPoint_VRAM(Ax, Ay+i));
			for(int i = 1; i < 14; i++) Bdisp_SetPoint_VRAM(Ax+i, Ay, !Bdisp_GetPoint_VRAM(Ax+i, Ay));
			for(int i = 1; i < 6; i++) Bdisp_SetPoint_VRAM(Ax+13, Ay+i, !Bdisp_GetPoint_VRAM(Ax+13, Ay+i));
			for(int i = 1; i < 14; i++) Bdisp_SetPoint_VRAM(Ax+i, Ay+6, !Bdisp_GetPoint_VRAM(Ax+i, Ay+6));
			Bdisp_PutDisp_DD();
			RestoreDisp(10);
			for(int i = 0; i <= MAP_XMAX; i++) for(int j = 0; j <= MAP_YMAX; j++) for(k = 0; k<50; k++) if(UnitesEnnemies[k].Get_Sprite(i,j)) Bdisp_SetPoint_VRAM(i,j,1);
			for(int i = 0; i < 7; i++) Bdisp_SetPoint_VRAM(Ax, Ay+i, !Bdisp_GetPoint_VRAM(Ax, Ay+i));
			for(int i = 1; i < 14; i++) Bdisp_SetPoint_VRAM(Ax+i, Ay, !Bdisp_GetPoint_VRAM(Ax+i, Ay));
			for(int i = 1; i < 6; i++) Bdisp_SetPoint_VRAM(Ax+13, Ay+i, !Bdisp_GetPoint_VRAM(Ax+13, Ay+i));
			for(int i = 1; i < 14; i++) Bdisp_SetPoint_VRAM(Ax+i, Ay+6, !Bdisp_GetPoint_VRAM(Ax+i, Ay+6));
			Bdisp_PutDisp_DD();
			RestoreDisp(10);
		}
		Ax++; Ay++;

		Timer_Set_On();
	}

// ===== KEY : STORE =====

	if(IsKeyDown(KEY_CHAR_STORE)) {
		SwitchUp();
	}

// ===== KEYs : KEYPAD =====

	if(IsKeyDown(KEY_CTRL_DEL)) {
		Sel_Delete();
	}

	if(IsKeyDown(KEY_CTRL_MENU)) {
		Timer_Set_Off();
		Menu();
		Timer_Set_On();
	}

	if(IsKeyDown(KEY_CHAR_0)) {
		if(IsKeyDown(KEY_CTRL_F6)) Sel_Save(0);
		else Sel_Restore(0);
		while(IsKeyDown(KEY_CHAR_0));
	}

	if(IsKeyDown(KEY_CHAR_1)) {
		if(IsKeyDown(KEY_CTRL_F6)) Sel_Save(1);
		else Sel_Restore(1);
		while(IsKeyDown(KEY_CHAR_1));
	}

	if(IsKeyDown(KEY_CHAR_2)) {
		if(IsKeyDown(KEY_CTRL_F6)) Sel_Save(2);
		else Sel_Restore(2);
		while(IsKeyDown(KEY_CHAR_2));
	}

	if(IsKeyDown(KEY_CHAR_3)) {
		if(IsKeyDown(KEY_CTRL_F6)) Sel_Save(3);
		else Sel_Restore(3);
		while(IsKeyDown(KEY_CHAR_3));
	}

	if(IsKeyDown(KEY_CHAR_4)) {
		if(IsKeyDown(KEY_CTRL_F6)) Sel_Save(4);
		else Sel_Restore(4);
		while(IsKeyDown(KEY_CHAR_4));
	}

	if(IsKeyDown(KEY_CHAR_5)) {
		if(IsKeyDown(KEY_CTRL_F6)) Sel_Save(5);
		else Sel_Restore(5);
		while(IsKeyDown(KEY_CHAR_5));
	}

	if(IsKeyDown(KEY_CHAR_6)) {
		if(IsKeyDown(KEY_CTRL_F6)) Sel_Save(6);
		else Sel_Restore(6);
		while(IsKeyDown(KEY_CHAR_6));
	}

	if(IsKeyDown(KEY_CHAR_7)) {
		if(IsKeyDown(KEY_CTRL_F6)) Sel_Save(7);
		else Sel_Restore(7);
		while(IsKeyDown(KEY_CHAR_7));
	}

	if(IsKeyDown(KEY_CHAR_8)) {
		if(IsKeyDown(KEY_CTRL_F6)) Sel_Save(8);
		else Sel_Restore(8);
		while(IsKeyDown(KEY_CHAR_8));
	}

	if(IsKeyDown(KEY_CHAR_9)) {
		if(IsKeyDown(KEY_CTRL_F6)) Sel_Save(9);
		else Sel_Restore(9);
		while(IsKeyDown(KEY_CHAR_9));
	}
}


// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________


void Cursor()
{
	if(IsKeyDown(KEY_CTRL_UP) || IsKeyDown(KEY_CTRL_DOWN) || IsKeyDown(KEY_CTRL_LEFT) || IsKeyDown(KEY_CTRL_RIGHT)) {
		RestoreDisp(1);
		if (IsKeyDown(KEY_CTRL_UP)) {
			curY--;
			if(curY == 0) {
				curY = 1;
				if (Ay != 1) {
					 Ay--;
					if(timePress > 5 && Ay != 1) Ay--;
				}
				Bdisp_PutScreen();
				timePress++;
			}
		}
		if (IsKeyDown(KEY_CTRL_DOWN)) {
			curY++;
			if(curY == 55) {
				curY = 54;
				if (Ay != MAP_YMAX - 6) {
					 Ay++;
					if((timePress > 5) && (Ay < MAP_YMAX - 6)) Ay++;
				}
				Bdisp_PutScreen();
				timePress++;
			}
		}
		if (IsKeyDown(KEY_CTRL_LEFT)) {
			curX--;
			if(curX == 0) {
				curX = 1;
				if (Ax != 1) {
					 Ax--;
					if(timePress > 5 && Ax != 1) Ax--;
				}
				Bdisp_PutScreen();
				timePress++;
			}
		}
		if (IsKeyDown(KEY_CTRL_RIGHT)) {
			curX++;
			if(curX == 110) {
				curX = 109;
				if (Ax != MAP_XMAX - 13) {
					 Ax++;
					if((timePress > 5) && (Ax < MAP_XMAX - 13)) Ax++;
				}
				Bdisp_PutScreen();
				timePress++;
			}
		}
		Bdisp_Cursor(curX, curY);
		Bdisp_PutDisp_DD();
	}
	else timePress = 0;
}

void Bdisp_PutScreen() {
	int i, j, k;
	char c[10];
	Bdisp_AllClr_VRAM();
	Sel_IsCross();
	Bdisp_MenuBar(Cross);

	i = 0;
	while (i < 14) {
		j = 0;
		while (j < 7) {
			tab [i][j] = -1;
			if(AsusDrivers) tab[i][j] = 0;
			k = 0;
			while (k < 50) {
				if (UnitesAlliees[k].Get_Sprite(i+Ax, j+Ay)) {
					tab[i][j] = UnitesAlliees[k].Get_Sprite(i+Ax, j+Ay);
					if(!UnitesAlliees[k].Get_IsStop()) Bdisp_WarFog(i,j);
				}
				if((tab[i][j] == -1) && ((Test_Range(UnitesAlliees[k].Get_PositionX(), UnitesAlliees[k].Get_PositionY(), UnitesAlliees[k].Get_Visibility(), i+Ax, j+Ay)) || ((UnitesAlliees[k].Get_Type() >= 20) && (Test_Range(UnitesAlliees[k].Get_PositionX(), UnitesAlliees[k].Get_PositionY()+1, UnitesAlliees[k].Get_Visibility(), i+Ax, j+Ay) || Test_Range(UnitesAlliees[k].Get_PositionX()+1, UnitesAlliees[k].Get_PositionY(), UnitesAlliees[k].Get_Visibility(), i+Ax, j+Ay) || Test_Range(UnitesAlliees[k].Get_PositionX()+1, UnitesAlliees[k].Get_PositionY()+1, UnitesAlliees[k].Get_Visibility(), i+Ax, j+Ay))))){
					tab[i][j] = 0;
				}
				k++;
			}
			if (tab[i][j] == 0) {
				k = 0;
				while (k < 16) {
					if(Monde[k].Get_Sprite(i+Ax, j+Ay)) {
						tab[i][j] = Monde[k].Get_Sprite(i+Ax, j+Ay);
					}
					k++;
				}
				k = 0;
				while (k < 50) {
					if (UnitesEnnemies[k].Get_Sprite(i+Ax, j+Ay)) {
						tab[i][j] = UnitesEnnemies[k].Get_Sprite(i+Ax, j+Ay);
						if(!UnitesEnnemies[k].Get_IsStop()) Bdisp_WarFog(i,j);
					}
					k++;
				}
			}
			switch(tab[i][j])
			{
				case -4 : Bdisp_Ressource(i, j); break;
				case -3 : Bdisp_Mount(i,j); break;
				case -2 : Bdisp_Tree(i,j); break;
				case -1 : Bdisp_WarFog(i,j); break;
				case 1 : Bdisp_Soldat(i,j); break;
				case 2 : Bdisp_Trooper(i,j); break;
				case 3 : Bdisp_AgentSpe(i,j); break;
				case 4 : Bdisp_Transporteur(i,j); break;
				case 5 : Bdisp_Char(i,j); break;
				case 6 : Bdisp_CharRot(i,j); break;
				case 7 : Bdisp_Helicoptere(i,j); break;
				case 8 : Bdisp_Chasseur(i,j);break;
				case 9 : Bdisp_Bombardier(i,j);break;
				case 10 : Bdisp_Mine(i,j);break;
				case 11 : Bdisp_Reparateur(i,j);break;
				case 12 : Bdisp_BaseAv(i,j);break;
				case 13 : Bdisp_TourDef(i,j);break;
				case 14 : Bdisp_Tourelle(i,j);break;
				case 15 : Bdisp_TourRot(i,j);break;
				case 16 : Bdisp_TourAv(i,j);break;
				case 21 : Bdisp_Capitole_TL(i,j);break;
				case 22 : Bdisp_Capitole_TR(i,j);break;
				case 23 : Bdisp_Capitole_BL(i,j);break;
				case 24 : Bdisp_Capitole_BR(i,j);break;
				case 26 : Bdisp_Caserne_TL(i,j);break;
				case 27 : Bdisp_Caserne_TR(i,j);break;
				case 28 : Bdisp_Caserne_BL(i,j);break;
				case 29 : Bdisp_Caserne_BR(i,j);break;
				case 31 : Bdisp_Usine_TL(i,j);break;
				case 32 : Bdisp_Usine_TR(i,j);break;
				case 33 : Bdisp_Usine_BL(i,j);break;
				case 34 : Bdisp_Usine_BR(i,j);break;
				case 36 : Bdisp_Aeroport_TL(i,j);break;
				case 37 : Bdisp_Aeroport_TR(i,j);break;
				case 38 : Bdisp_Aeroport_BL(i,j);break;
				case 39 : Bdisp_Aeroport_BR(i,j);break;
				case 41 : Bdisp_TourSup_TT(i,j);break;
				case 43 : Bdisp_TourSup_BB(i,j);break;
				case 46 : Bdisp_BaseMiss_TL(i,j);break;
				case 47 : Bdisp_BaseMiss_TR(i,j);break;
				case 48 : Bdisp_BaseMiss_BL(i,j);break;
				case 49 : Bdisp_BaseMiss_BR(i,j);break;
				case 51 : Bdisp_BunkeRap_TL(i,j);break;
				case 52 : Bdisp_BunkeRap_TR(i,j);break;
				case 53 : Bdisp_BunkeRap_BL(i,j);break;
				case 54 : Bdisp_BunkeRap_BR(i,j);break;
			}
			j++;
		}
		i++;
	}

	Bdisp_PutSelected();
	int2str(c, money);
	if(RichMen){
		PrintMini(115,2,(unsigned char*) "---", MINI_OVER);
	}
	else{
		PrintMini(115,2,(unsigned char*) c,MINI_OVER);
	}

	SaveDisp(1);

	Bdisp_Cursor(curX, curY);
	Bdisp_AllClr_DD();
	Bdisp_PutDisp_DD();
}

// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________

void Game()
{
	AsusDrivers = false;
	Set_Brainstorm(false);
	Bdisp_AllClr_DDVRAM();
	Unselect();
	Cursor();
	Begin(&UnitesEnnemies[0]);
	SetTimer(2,500,Boucle);
	Timer_Set_On();
	Cross_On();
	int EndOfTheGame = 0;
	while(EndOfTheGame == 0)
	{
		Cursor();
		Get();
		EndOfTheGame = End_Test();
	}
	Timer_Set_Off();
	Timer_Set(0);
	while (IsKeyUp(KEY_CTRL_EXE)) {
		PopUpWin(3);
		locate(5,4);
		if(EndOfTheGame == 1){
			Print((unsigned char*) "You Loose :-(");
		}
		else{
			Print((unsigned char*) " You Win ;-)");
		}
		Bdisp_PutDisp_DD();
	}
}

void Alea()
{
	while (IsKeyDown(KEY_CTRL_EXE)) rand();

	int a, b, i;
	Ax = 1;
	Ay = 1;
	curX = 63;
	curY = 31;
	MAP_AREA = 950;	

	Timer_Set(0.0);

	MAP_XMAX = ((int)(sqrt(MAP_AREA)*1/2)) + ((int)((float)rand()*sqrt(MAP_AREA)/(RAND_MAX+1)));
	MAP_YMAX = MAP_AREA / MAP_XMAX;

	UnitesAlliees[0].Create(20,2,2);

	UnitesEnnemies[0].Create(20,MAP_XMAX - 2,MAP_YMAX - 2);

	// Placement des lments du monde

	i = 0;
	while (i < 8) {// les 8 arbres
		a = (1+(int)((float)rand()*MAP_XMAX/(RAND_MAX+1)));
		b = (1+(int)((float)rand()*MAP_YMAX/(RAND_MAX+1)));
		if(Test_XY(a,b) == 0) Monde[i].Create(-2,a,b);
		else i--;
		i++;
	}
	while (i < 12) {// 4 mines au hasard
		a = (1+(int)((float)rand()*MAP_XMAX/(RAND_MAX+1)));
		b = (1+(int)((float)rand()*MAP_YMAX/(RAND_MAX+1)));
		if(Test_XY(a,b) == 0) Monde[i].Create(-4,a,b);
		else i--;
		i++;
	}
	while (i < 14) {// 2 mines prs de la base ennemie
		a = (MAP_XMAX-3-(int)((float)rand()*5 / (RAND_MAX+1)));
		b = (MAP_YMAX-3-(int)((float)rand()*5 / (RAND_MAX+1)));
		if(Test_XY(a,b) == 0) Monde[i].Create(-4,a,b);
		else i--;
		i++;
	}
	while (i < 16) {// 2 mines prs de la base allie
		a = (1+(int)((float)rand()*5 / (RAND_MAX+1)));
		b = (1+(int)((float)rand()*5 / (RAND_MAX+1)));
		if(Test_XY(a,b) == 0) Monde[i].Create(-4,a,b);
		else i--;
		i++;
	}

	money = 1500;

	Game();
}

void Missions()
{
	MAP_AREA = 3969;
	MAP_XMAX = 63;
	MAP_YMAX = 63;

	while (IsKeyDown(KEY_CTRL_EXE)) rand();
	int a, b, i;
	Ax = 1;
	Ay = 1;
	curX = 63;
	curY = 31;
	Timer_Set(0.0);

	UnitesAlliees[0].Create(20,2,2);
	UnitesAlliees[1].Create(25,2,5);
	UnitesAlliees[2].Create(30,2,7);
	UnitesAlliees[3].Create(35,2,9);
	UnitesAlliees[5].Create(45,7,2);
	UnitesAlliees[6].Create(50,9,2);
	UnitesAlliees[7].Create(40,10,10);

	UnitesEnnemies[0].Create(20,MAP_XMAX - 2,MAP_YMAX - 2);
	UnitesEnnemies[1].Create(25,MAP_XMAX - 2,MAP_YMAX - 5);
	UnitesEnnemies[2].Create(30,MAP_XMAX - 2,MAP_YMAX - 8);
	UnitesEnnemies[3].Create(35,MAP_XMAX - 5,MAP_YMAX - 2);
	UnitesEnnemies[4].Create(16,MAP_XMAX - 5,MAP_YMAX - 5);

	i = 0;
	while (i < 8) {
	}
	while (i < 12) {
		a = (1+(int)((float)rand()*MAP_XMAX/(RAND_MAX+1)));
		b = (1+(int)((float)rand()*MAP_YMAX/(RAND_MAX+1)));
		if(Test_XY(a,b) == 0) Monde[i].Create(-4,a,b);
		else i--;
		i++;
	}
	while (i < 14) {
		a = (MAP_XMAX - 3 - (int)((float)rand()*5 / (RAND_MAX+1)));
		b = (MAP_YMAX - 3 - (int)((float)rand()*5 / (RAND_MAX+1)));
		if(Test_XY(a,b) == 0) Monde[i].Create(-4,a,b);
		else i--;
		i++;
	}
	while (i < 16) {
		a = (1+(int)((float)rand()*5 / (RAND_MAX+1)));
		b = (1+(int)((float)rand()*10/(RAND_MAX+1)));
		if(Test_XY(a,b) == 0) Monde[i].Create(-4,a,b);
		else i--;
		i++;
	}

	money = 40000;

	Game();
}


// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________


void Saver()
{
	FONTCHARACTER saved1[] = {'\\','\\','f','l','s','0','\\','S','A','V','E','-','1','.','C','T','E',0};
	float Settings[9];	
	int file;

	Bfile_DeleteFile(saved1);

	Bfile_CreateFile(saved1, 10+100*sizeof(Unite)+16*sizeof(WorldShip)+7*sizeof(float));

	file = Bfile_OpenFile(saved1, _OPENMODE_WRITE);
	Bfile_WriteFile(file, "CTE by TTP",10);
	Bfile_WriteFile(file, UnitesAlliees,50*sizeof(Unite));
	Bfile_WriteFile(file, UnitesEnnemies,50*sizeof(Unite));
	Bfile_WriteFile(file, Monde,16*sizeof(WorldShip));
	Settings[0] = money;
	Settings[1] = Get_Money_Ennemis();
	Settings[2] = Ax;
	Settings[3] = Ay;
	Settings[4] = curX;
	Settings[5] = curY;
	Settings[6] = MAP_XMAX;
	Settings[7] = MAP_YMAX;
	Settings[8] = Timer_GetTime();
	Bfile_WriteFile(file, Settings,9*sizeof(float));
	Bfile_CloseFile(file);
}

bool Loader()
{
	FONTCHARACTER saved1[] = {'\\','\\','f','l','s','0','\\','S','A','V','E','-','1','.','C','T','E',0};
	unsigned int key;
	float Settings[9];
	char Header[10];
	int file;
	file = Bfile_OpenFile(saved1, _OPENMODE_READ);
	if (file > 0)  {
		Bfile_ReadFile(file, Header, 10,0);
		if(Header != "CTE by TTP") {
			Bfile_ReadFile(file, UnitesAlliees,50*sizeof(Unite),10);
			Bfile_ReadFile(file, UnitesEnnemies,50*sizeof(Unite),10+50*sizeof(Unite));
			Bfile_ReadFile(file, Monde,16*sizeof(WorldShip),10+100*sizeof(Unite));
			Bfile_ReadFile(file, Settings,9*sizeof(float),10+100*sizeof(Unite)+16*sizeof(WorldShip));
			Bfile_CloseFile(file);
			money = Settings[0];
			Make_MoneyMore(Settings[1]-40000);
			Ax = Settings[2];
			Ay = Settings[3];
			curX = Settings[4];
			curY = Settings[5];
			MAP_XMAX = Settings[6];
			MAP_YMAX = Settings[7];
			Timer_Set(Settings[8]);
			return true;
		}
		else {
			PopUpWin(1);
			locate(5,4);
			Print((unsigned char*) "File error !");
			Bdisp_PutDisp_DD();
			GetKeyWait(KEYWAIT_HALTON_TIMEROFF, 0, 1, &key);
			return false;
		}
	}
	else {
		PopUpWin(1);
		locate(5,4);
		Print((unsigned char*) "Loading error !");
		Bdisp_PutDisp_DD();
		GetKeyWait(KEYWAIT_HALTON_TIMEROFF, 0, 1, &key);
		return false;
	}
}

void Menu()
{
	int pos = 3;
	PopUpWin(5);
	locate(8,2);
	Print((unsigned char*) "Pause");
	locate(4,3);
	Print((unsigned char*) "o Continue");
	locate(6,4);
	Print((unsigned char*) "Save");
	locate(6,5);
	Print((unsigned char*) "Quit");

	while(IsKeyUp(KEY_CTRL_EXE)) {
		if(IsKeyDown(KEY_CTRL_UP) && (pos != 3)) {
			locate(4, pos); Print(" ");
			pos --;
			locate(4, pos); Print("o");
			Sleep(250);
		}
		if(IsKeyDown(KEY_CTRL_DOWN) && (pos != 5)) {
			locate(4, pos); Print(" ");
			pos ++;
			locate(4, pos); Print("o");
			Sleep(250);
		}
		Bdisp_PutDisp_DD();
	}

	if(pos == 4) Saver();
	if(pos == 5) Screen_Quit();
	
}

// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________

void Tutorial()
{
	Bdisp_AllClr_DDVRAM();
	locate(4,3); Print((unsigned char*) "No tutorial yet... ");
	locate(7,4); Print((unsigned char*) "Sorry !");
	Bdisp_PutDisp_DD();
	while(IsKeyDown(KEY_CTRL_EXE));
	while(IsKeyUp(KEY_CTRL_EXE));
}

// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________
