extern "C"
{
#include "fxlib.h"
#include "stdlib.h"
#include "stddef.h"
}

#include "Classes.hpp"
#include "Game.hpp"
#include "OtherFunc.hpp"

Unite *Commando[10];
Unite *Base[5];
Unite *Target = 0;
int moneyE;

int Get_Money_Ennemis()
{
	return moneyE;
}

void Make_MoneyMore(int i)
{
	moneyE += i;
}

void Begin(Unite  *base)
{
	int i = 0;
	for(int j = 0; j < 50; j++) {
		if(GetUnit_Ennemie(j)->Get_Type() == 1) {
			Commando[i] = GetUnit_Ennemie(j);
			i++;
			if (i == 10) break; 
		}
	}
	for(i; i < 10; i++) Commando[i] = 0;
	i = 0;
	for(int j = 0; j < 50; j++) {
		if((GetUnit_Ennemie(j)->Get_Type() == 4) || (GetUnit_Ennemie(j)->Get_Type() == 12) || (GetUnit_Ennemie(j)->Get_Type() == 20)) {
			Base[i] = GetUnit_Ennemie(j);
			i++;
			if (i == 10) break; 
		}
	}
	for(i; i < 5; i++)  Base[i] = 0;
	moneyE = 1500;
}

void Action_Attack()
{
	for(int i = 0; i < 10; i++) {
		bool Deux = true;
		if(Commando[i]->Get_IsAttacking()) {
			Deux = false;
		}
		if(Deux) {
			for(int j = 0; j < 50; j++) {
				if(Test_Range(Commando[i]->Get_PositionX(), Commando[i]->Get_PositionY(), Commando[i]->Get_Visibility(), GetUnit_Alliee(j)->Get_PositionX(), GetUnit_Alliee(j)->Get_PositionY())) {
					Commando[i]->Attack(GetUnit_Alliee(j));
					Deux = false;
					if(GetUnit_Alliee(j)->Get_Type() == 20) {
						Target = GetUnit_Alliee(j);
					}//end if
				}// end if
			}// end for
			if(Deux && Commando[i]->Get_Move()) {
				if((Target != 0) && (Target->Get_Type() != 0)){
					Commando[i]->Attack(Target);
				}// end if
				else {
					Commando[i]->GoTo(1+(int)((float)rand()*Get_MAP_XMAX()/(RAND_MAX+1)), 1+(int)((float)rand()*Get_MAP_YMAX()/(RAND_MAX+1)));
				}//end else
			}//end if
		}// end if
	}// end for
}// .

void Action_Defense(int n)
{
	for(int i = 0; i < 10; i++) {
		bool Deux = true;
		for(int j = 0; j < 50; j++) {
			if(Test_Range(Commando[i]->Get_PositionX(), Commando[i]->Get_PositionY(), Commando[i]->Get_Visibility(), GetUnit_Alliee(j)->Get_PositionX(), GetUnit_Alliee(j)->Get_PositionY()) || (Commando[i]->Get_IsAttacking())) {
				Commando[i]->Attack(GetUnit_Alliee(j));
				Deux = false;
			}
		}
		if(Deux && Commando[i]->Get_Move()) {
			Commando[i]->GoTo(Base[n]->Get_PositionX(), Base[n]->Get_PositionY());
		}
	}
}

bool Test_Base()
{
	int k;
	for(int i = 0; i<5; i++) {
		if (Base[i] != 0) {
			if (Base[i]->Get_Type() == 0) {
				Base[i] = 0;
				k++;
			}// end if (is destroyed)
		}// end if (exist)
		else k++;
	}// end for
	if (k == 5) return false;
	else return true;
}

bool Test_Batiments()
{
	int j = 0;
	int k,l;
	Unite* Build;
	for(int i = 0; i<5; i++) {
		if (Base[i] != 0) {
			if(Base[i]->Get_Type() == 20){
				if(!CanSee_Ennemie(Base[i], 10) && (j == 0)) {
					if(Base[i]->Get_IsStop() && (moneyE > Get_Prize(10))) {
						Build = NewUnit_Ennemie();
						while(1) {
							k = 0;
							k = (Base[i]->Get_PositionX()-5)+(int)((float)rand()*10/(RAND_MAX+1));
							if(k < 1) k = 1;
							if(k > Get_MAP_XMAX()) k = Get_MAP_XMAX();
							l = 0;
							l = (Base[i]->Get_PositionY()-5+(int)((float)rand()*10/(RAND_MAX+1)));
							if(l < 1) l = 1; if(l > Get_MAP_YMAX()) l = Get_MAP_YMAX();
							if(Test_Range(Base[i]->Get_PositionX(), Base[i]->Get_PositionY(), 10, k,l) && (Test_XY(k,l) == -4)) break;
						}
						moneyE -= Get_Prize(10);
						Build->Create(10,k,l);
						Build->Stop(Get_BuildTime(10));
						Base[i]->Stop(Get_BuildTime(10));
					}
					j++;
				}// end if (CanSee)

				if(!CanSee_Ennemie(Base[i], 25) && (j == 0)) {
					if(Base[i]->Get_IsStop() && (moneyE > Get_Prize(25))) {
						Build = NewUnit_Ennemie();
						while(1) {
							k = 0;
							k = (Base[i]->Get_PositionX()-5)+(int)((float)rand()*10/(RAND_MAX+1));
							if(k < 1) k = 1; if(k > Get_MAP_XMAX() - 1) k = Get_MAP_XMAX() - 1;
							l = 0;
							l = (Base[i]->Get_PositionY()-5+(int)((float)rand()*10/(RAND_MAX+1)));
							if(l < 1) l = 1; if(l > Get_MAP_YMAX() - 1) l = Get_MAP_YMAX() - 1;
							if(Test_Range(Base[i]->Get_PositionX(), Base[i]->Get_PositionY(), 10, k,l) && (Test_XY(k,l) == 0) && (Test_XY(k+1,l) == 0) && (Test_XY(k,l+1) == 0) && (Test_XY(k+1,l+1) == 0)) break;
						}
						moneyE -= Get_Prize(25);
						Build->Create(25,k,l);
						Build->Stop(Get_BuildTime(25));
						Base[i]->Stop(Get_BuildTime(25));
					}
					j++;
				}// end if (CanSee)

				if(!CanSee_Ennemie(Base[i], 15) && (j == 0)) {
					if(Base[i]->Get_IsStop() && (moneyE > Get_Prize(15))) {
						Build = NewUnit_Ennemie();
						while(1) {
							k = 0;
							k = (Base[i]->Get_PositionX()-5)+(int)((float)rand()*5/(RAND_MAX+1));
							if(k < 1) k = 1; if(k > Get_MAP_XMAX()) k = Get_MAP_XMAX();
							l = 0;
							l = (Base[i]->Get_PositionY()-5+(int)((float)rand()*5/(RAND_MAX+1)));
							if(l < 1) l = 1; if(l > Get_MAP_YMAX()) l = Get_MAP_YMAX();
							if(Test_Range(Base[i]->Get_PositionX(), Base[i]->Get_PositionY(), 10, k,l) && (Test_XY(k,l) == 0)) break;
						}
						moneyE -= Get_Prize(15);
						Build->Create(15,k,l);
						Build->Stop(Get_BuildTime(15));
						Base[i]->Stop(Get_BuildTime(15));
					}
					j++;
				}// end if (CanSee)

				if(!CanSee_Ennemie(Base[i], 30) && (j == 0)) {
					if(Base[i]->Get_IsStop() && (moneyE > Get_Prize(30))) {
						Build = NewUnit_Ennemie();
						while(1) {
							k = 0;
							k = (Base[i]->Get_PositionX()-5)+(int)((float)rand()*10/(RAND_MAX+1));
							if(k < 1) k = 1; if(k > Get_MAP_XMAX() - 1) k = Get_MAP_XMAX() - 1;
							l = 0;
							l = (Base[i]->Get_PositionY()-5+(int)((float)rand()*10/(RAND_MAX+1)));
							if(l < 1) l = 1; if(l > Get_MAP_YMAX() - 1) l = Get_MAP_YMAX() - 1;
							if(Test_Range(Base[i]->Get_PositionX(), Base[i]->Get_PositionY(), 10, k,l) && (Test_XY(k,l) == 0) && (Test_XY(k+1,l) == 0) && (Test_XY(k,l+1) == 0) && (Test_XY(k+1,l+1) == 0)) break;
						}
						moneyE -= Get_Prize(30);
						Build->Create(30,k,l);
						Build->Stop(Get_BuildTime(30));
						Base[i]->Stop(Get_BuildTime(30));
					}
					j++;
				}// end if (CanSee)
			}// end if (Type)
			else {
				Base[i] = 0;
			}// end else
		}// end if (exists)
	}// end for
	if (j == 0) return true;
	else return false;
}

bool Test_Commando()
{
	for(int i = 0; i < 10; i++) {
		if(Commando[i] == 0) return false;
		if(Commando[i]->Get_Type() == 0) {
			Commando[i] = 0;
			return false;
		}
	}
	return true;
}

void Make_Commando()
{
	int i, j;
	Unite* Build;
	for(i = 0; GetUnit_Ennemie(i)->Get_Type() != 25; i++) {
		if(i >= 50) return;
	}
	if (GetUnit_Ennemie(i)->Get_IsStop() && (moneyE > Get_Prize(1))) {
		for(j = 0; (Commando[j] != 0) && (j < 10); j++);
		Build = NewUnit_Ennemie(); 
		moneyE -= Get_Prize(1);
		Build->Create(1,GetUnit_Ennemie(i)->Get_PositionX(), GetUnit_Ennemie(i)->Get_PositionY() - 1);
		Build->Stop(Get_BuildTime(1));
		Build->GoTo(GetUnit_Ennemie(i)->Get_PositionX() - 5, GetUnit_Ennemie(i)->Get_PositionY() - 2);
		GetUnit_Ennemie(i)->Stop(Get_BuildTime(1));
		for(int i = 0; i < 10; i++) {
			if(Commando[i] == 0) {
				Commando[i] = Build;
				break;
			}
		}
	}
}

bool NoAttack()
{
//	for(int i = 0; i<5; i++) {
//		if (Base[i] != 0) {
//			if(CanSee_Allie(Base[i])) {
//				Action_Defense(i);
//				return false;
//			}
//		}
//	}
	Action_Attack();
	return true;
}

void Boucle()
{
	if (Test_Base()) {
		if(Test_Batiments()) {
			if(Test_Commando()) {
				NoAttack();
			}
			else {
				Make_Commando();
			}
		}
	}
}